# std::stack<T,Container>::emplace

From cppreference.com
< cpp‎ | container‎ | stack

template< class... Args > void emplace( Args&&... args ); |  | (since C++11) (until C++17)
template< class... Args > decltype(auto) emplace( Args&&... args ); |  | (since C++17)

Pushes a new element on top of the stack. The element is constructed in-place, i.e. no copy or move operations are performed. The constructor of the element is called with exactly the same arguments as supplied to the function.

Effectively calls c.emplace_back(std::forward<Args>(args)...);

### Parameters

args | - | arguments to forward to the constructor of the element

### Return value

(none) | (until C++17)
The value or reference, if any, returned by the above call to Container::emplace_back. | (since C++17)

### Complexity

Identical to the complexity of Container::emplace_back.

### Defect reports

The following behavior-changing defect reports were applied retroactively to previously published C++ standards.

DR | Applied to | Behavior as published | Correct behavior
--- | --- | --- | ---
LWG 2783 | C++17 | `emplace` returned `reference`, breaking compatibility with pre-C++17 containers | returns `decltype(auto)`

### See also

push | inserts element at the top (public member function)
pop | removes the top element (public member function)

Retrieved from "https://en.cppreference.com/mwiki/index.php?title=cpp/container/stack/emplace&oldid=50668"